#!/usr/bin/env perl
 
my $MAX_PER_LINE=6;
$i = 1;

my $chromMap = $ARGV[0];
my %map = {};
print STDERR "$chromMap\n";
open FILEA, "< $chromMap";
while (<FILEA>) {
   my @splitLine = split;
   $map{$splitLine[0]} = $splitLine[1];
}
close(FILEA);

my $chrom = undef;

print "{   chromosomes = (\n";

my $doPrint = 1;
my $doQPrint = 0;
my $isClosed = 0;

# get tranlation to small and large chromosomes
my %chrCentStart = {};
my %chrCentEnd = {};
my %chrPCent = {};
my %chrQCent = {};
if ($#ARGV >= 3) {
   open FILEC, "< $ARGV[3]";
   while(<FILEC>){
      chomp;
      my @splitLine = split;
      if ($splitLine[4] eq "acen") {
         if (!defined($chrCentStart{$splitLine[0]})) { $chrCentStart{$splitLine[0]} = $splitLine[2]; $chrPCent{$splitLine[0]} = "$splitLine[1]_$splitLine[2]"; }
         elsif (!defined($chrCentEnd{$splitLine[0]})) { $chrCentEnd{$splitLine[0]} = $splitLine[1]; $chrQCent{$splitLine[0]} = "$splitLine[1]_$splitLine[2]"; }
      }
   }
   close(FILEC);
}


open FILEB, "< $ARGV[1]";
while(<FILEB>){
    if(/^>(.*) ([0-9]*) bases/) {
        if (defined($chrom) && $doPrint) { $isClosed = 1; print ");\n},\n"; }
        $chrom = $1;
        $length=$2;

        if (defined($map{$chrom})) {
           $doPrint = 1;
           $chrom = $map{$chrom};
        } else {
           $doPrint = 0;
        }

        if ($doPrint) {
           $isClosed = 0;
           print "{\n";
           print "name = \"$chrom\";\n";
           if (!defined($chrCentStart{$chrom})) {
              print "size= \"$length\";\n";
              print "banding = (\n";
           } else {
              print "p= \"$chrCentStart{$chrom}\";\n";
              my $qStart = $length - $chrCentEnd{$chrom};
print STDERR "For chr $chrom ($length) the start is $chrPCent{$chrom} and end $chrQCent{$chrom} $qStart pends at $chrCentEnd{$chrom}\n";
              print "q= \"$qStart\";\n";
              print "pBanding = (\n";
              $doQPrint = 1;
           }
        }
    }
    else {
        my @splitLine = split;
        @contig = split(/\|/,$splitLine[7]);
        $strand = $_[6];
        if ($doPrint) {
           if (defined($chrCentStart{$chrom})) {
              if ($splitLine[1] <= $chrCentStart{$chrom}) { 
                 $start = $splitLine[0]/$chrCentStart{$chrom};
                 $stop = $splitLine[1]/$chrCentStart{$chrom};
              } elsif ($splitLine[0] >= $chrCentEnd{$chrom}) {
                 if ($doQPrint) { 
                    my @cent = split("_", $chrPCent{$chrom});
                    my $start = $cent[0]/$chrCentStart{$chrom};
                    my $stop = $cent[1]/$chrCentStart{$chrom};
                    print "{name=\"pcent\"; stop=\"$stop\"; start=\"$start\"; color=centromere; },\n";
                    print ");\nqBanding = (\n"; $doQPrint = 0; 
                    my @cent = split("_", $chrQCent{$chrom});
                    $start = 0;
                    $stop = ($cent[1]-$chrCentEnd{$chrom})/($length - $chrCentEnd{$chrom});
                    print "{name=\"qcent\"; stop=\"$stop\"; start=\"$start\"; color=centromere; },\n";
                    $i = 0;
                 }
                 $start = ($splitLine[0]-$chrCentEnd{$chrom})/($length - $chrCentEnd{$chrom});
                 $stop = ($splitLine[1]-$chrCentEnd{$chrom})/($length - $chrCentEnd{$chrom});
              } else {
print STDERR "Error: contig $contig[0] hits chetromere on $chrom\n";
              }
           } else {
              $start = $splitLine[0]/$length;
              $stop = $splitLine[1]/$length;
           }
           if ($i % 2 == 0) {
              print "{name=\"$contig[0]\"; stop=\"$stop\"; start=\"$start\";color=grey; },\n";
           } else {
              print "{name=\"$contig[0]\"; stop=\"$stop\"; start=\"$start\";color=chrome},\n";
          }
        }
        $i++;
}
}
close(FILEB);
if ($isClosed == 0) {
   print ");\n";
   print "},\n";
}
print ");\n";
# finally output the placements
print "placements = {\n";
print "    standard = {\n";
print "        borderLeft = 50;\n";
print "        borderTop = 20;\n";
print "        borderButtom = 0;\n";
print "        chromosomeWidth = 30;\n";
print "        spacing = 40;\n";
print "        drawBanding = YES;\n";
print "        drawBandNames = standard;\n";
print "        intergroupSpacing = 40;\n";
print "        internalAnnotations = (\n";
print "              {\n";
print "                name = banding;\n";
print "                config = { drawBandingWithVisualEffect = chrome; };\n";
print "                                },\n";
print "                {name = itags;\n";
print "                 config = {\n";
print "                      /* height in percent of maximal chromosome length */\n";
print "                        defaultColorHeight = 0.0005;\n";
print "                          };\n";
print "                        }\n";
print "                        );\n";
print "        annotations = (\n";
print "             {\n";
print "               name = bandingNames;\n";
print "               config = { config = standard; };\n";
print "                        },\n";
print "                {\n";
print "                name = etags;\n";
print "                config = { config = standard; };\n";
print "                        }\n";
print "                        );\n";
print "                paperSize = { width = 800; height = 800; };\n";
print "                namesize = 14;\n";
print "                /* now the lanes are filled with chromosome names, which are grouped */\n";
print "                lanes = (\n";
# if we have lane spec, use it otherwise just distribute all
if ($#ARGV >= 2) {
   open FILEC, "< $ARGV[2]";
   while(<FILEC>){
      chomp;
      print "$_\n";
   }
   close(FILEC);
} else {
   my $count = 0;
   my $currString = "(";
   foreach my $item (keys(%map)) {
      $currString = ($currString eq "(" || $currString eq "" ? $map{$item} : "$currString, $map{$item}");
      if ($count >= $MAX_PER_LINE) { print "$currString\n"; $count = 0; $currString="";}
      $count++;
   }
}
print "                        );\n";
print "                colors = (\n";
print "                        { r = 0.0; g = 0.0; b = 1.0; },\n";
print "                        { r = 1.0; g = 0.0; b = 0.0; }\n";
print "                        );\n";
print "                };\n";
print "        };\n";
print "}\n";
